unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, TAGraph,
  TASeries, TATransformations;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    ChartAxisTransformations1: TChartAxisTransformations;
    LogTransform: TLogarithmAxisTransform;
    CheckBox1: TCheckBox;
    procedure CheckBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure SetLogY(Enable: Boolean);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  Math,
  TACustomSource;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to 100 do
    Chart1LineSeries1.AddXY(i, exp(-i*0.05) + Randg(0, 0.01) + 0.1);

  // Das kann man alles im Object Inspektor machen
  LogTransform.Base := 10;
  LogTransform.Enabled := false;
  Chart1.LeftAxis.Transformations := ChartAxisTransformations1;
  Chart1LineSeries1.AxisIndexY := 0;  // das ist der Index der Achse, die logarithmiert werden soll
end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  SetLogY(Checkbox1.Checked);
end;

procedure TForm1.SetLogY(Enable: Boolean);
begin
  if Enable then begin
    Chart1.LeftAxis.Intervals.Options := Chart1.LeftAxis.Intervals.Options + [aipGraphCoords];
    Chart1.LeftAxis.Intervals.MaxLength := 120;
    Chart1.LeftAxis.Intervals.tolerance := 50;
  end else
  begin
    Chart1.LeftAxis.Intervals.Options := Chart1.LeftAxis.Intervals.Options - [aipGraphCoords];
    Chart1.LeftAxis.Intervals.MaxLength := 50;
    Chart1.LeftAxis.Intervals.tolerance := 0;
  end;
  LogTransform.Enabled := Enable;
end;

end.

